// ViewAudio.dll v0.3.01 Copyright(C) 2003 minamina
// Avisynth Plugin - View Audio (YUY2 and YV12 Only)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA, or visit
// http://www.gnu.org/copyleft/gpl.html .

#ifndef _VIEW_AUDIO_H
#define _VIEW_AUDIO_H

#ifdef _MSC_VER
	#include <crtdbg.h>
#else
	#define _ASSERTE(x) assert(x)
	#include <assert.h>
#endif

#include <windows.h>

#pragma warning (push, 3)
//#include <boost/shared_ptr.hpp>
//#include <boost/lexical_cast.hpp>
#include "avisynth.h"
#pragma warning (pop)

#define DEFAULT_DRAW_BOX_HEIGHT (80)

class ViewAudio : public GenericVideoFilter
{
private:
	int m_nSideFrames;
	int m_nDrawBoxTop;
	int m_nDrawBoxHeight;
	int m_nDrawFrames;
	bool m_bFillDrawBox;
	int m_nDrawChannel;

	BYTE* m_pAudioBuffer;

	int m_nDrawAudioSamples;
	int m_nAudioChannels;

public:
	static void PluginInit(IScriptEnvironment *env)
	{ env->AddFunction(GetName(), GetParams(), Create, 0); }

	ViewAudio(PClip _child, const int nSideFrames, const int nDrawBoxTop, const int nDrawBoxHeight,
		const bool bFillDrawBox, const int nDrawChannel, IScriptEnvironment* env);
	virtual ~ViewAudio()
	{
		if (m_pAudioBuffer != NULL)
		{
			delete [] m_pAudioBuffer;
			m_pAudioBuffer = NULL;
		}
	};

private:
	static AVSValue __cdecl Create(AVSValue args, void* /*user_data*/, IScriptEnvironment *env)
	{ return new ViewAudio(args[0].AsClip(), args[1].AsInt(2), args[2].AsInt(-1), args[3].AsInt(DEFAULT_DRAW_BOX_HEIGHT), args[4].AsBool(true), args[5].AsInt(-1), env); }
	static const char *GetName() { return "ViewAudio"; }
	static const char *GetParams() { return "c[frames]i[top]i[height]i[fill]b[channel]i"; }

	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
	inline void CopyFrame(const PVideoFrame& frameSrc, const PVideoFrame& frameDest, IScriptEnvironment *env);
	inline void FillDrawBox(const PVideoFrame& frameDest);
	inline void DrawBoxLine(const PVideoFrame& frameDest);
	inline void DrawAudioChannel(const PVideoFrame& frameDest, const int nChannel);
};

#endif // _VIEW_AUDIO_H
